package jdbc.example.employee.bean;

import java.sql.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

import org.codehaus.jackson.annotate.JsonProperty;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import jdbc.example.dependant.bean.Dependants;

@XmlAccessorType(XmlAccessType.NONE)

@XmlRootElement(name = "Employee")
public class Employee {
	private static Logger log = LoggerFactory.getLogger(Employee.class);
	@JsonProperty("dependants")
	Dependants dependants;
	private String address;
	private Double basicSal;
	private Date dateOfJoining;
	private String deptCode;
	private String empId;
	private Long employeeKey;
	private String name;
	private String tableName;

	@Override
	public String toString() {

		StringBuilder builder = new StringBuilder();
		builder.append("\n address=" + address);
		builder.append("\n basicSal=" + basicSal);
		builder.append("\n dateOfJoining=" + dateOfJoining);
		builder.append("\n deptCode=" + deptCode);
		builder.append("\n empId=" + empId);
		builder.append("\n employeeKey=" + employeeKey);
		builder.append("\n name=" + name);
		builder.append("\n tableName=" + tableName);
		return builder.toString();

	}

	@XmlAttribute(name = "Address")
	public String getAddress() {
		return address;
	}

	@XmlAttribute(name = "BasicSal")
	public Double getBasicSal() {
		return basicSal;
	}

	@XmlAttribute(name = "DateOfJoining")
	public Date getDateOfJoining() {
		return dateOfJoining;
	}

	@XmlAttribute(name = "DeptCode")
	public String getDeptCode() {
		return deptCode;
	}

	@XmlAttribute(name = "EmpId")
	public String getEmpId() {
		return empId;
	}

	@XmlAttribute(name = "EmployeeKey")
	public Long getEmployeeKey() {
		return employeeKey;
	}

	@XmlAttribute(name = "Name")
	public String getName() {
		return name;
	}

	@XmlAttribute(name = "TableName")
	public String getTableName() {
		return tableName;
	}

	@XmlElement(name = "Dependants")
	public Dependants getDependants() {
		if (dependants == null)
			dependants = new Dependants();
		return dependants;
	}

	public static void setLog(Logger log) {
		Employee.log = log;
	}

	public void setDependants(Dependants dependants) {
		this.dependants = dependants;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public void setBasicSal(Double basicSal) {
		this.basicSal = basicSal;
	}

	public void setDateOfJoining(Date dateOfJoining) {
		this.dateOfJoining = dateOfJoining;
	}

	public void setDeptCode(String deptCode) {
		this.deptCode = deptCode;
	}

	public void setEmpId(String empId) {
		this.empId = empId;
	}

	public void setEmployeeKey(Long employeeKey) {
		this.employeeKey = employeeKey;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

}
